package com.neusoft.smart.pos.payorder.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class PayRefundOrderExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public PayRefundOrderExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public PayRefundOrderExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMcodeIsNull() {
            addCriterion("mcode is null");
            return (Criteria) this;
        }

        public Criteria andMcodeIsNotNull() {
            addCriterion("mcode is not null");
            return (Criteria) this;
        }

        public Criteria andMcodeEqualTo(String value) {
            addCriterion("mcode =", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeNotEqualTo(String value) {
            addCriterion("mcode <>", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeGreaterThan(String value) {
            addCriterion("mcode >", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeGreaterThanOrEqualTo(String value) {
            addCriterion("mcode >=", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeLessThan(String value) {
            addCriterion("mcode <", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeLessThanOrEqualTo(String value) {
            addCriterion("mcode <=", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeLike(String value) {
            addCriterion("mcode like", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeNotLike(String value) {
            addCriterion("mcode not like", value, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeIn(List<String> values) {
            addCriterion("mcode in", values, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeNotIn(List<String> values) {
            addCriterion("mcode not in", values, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeBetween(String value1, String value2) {
            addCriterion("mcode between", value1, value2, "mcode");
            return (Criteria) this;
        }

        public Criteria andMcodeNotBetween(String value1, String value2) {
            addCriterion("mcode not between", value1, value2, "mcode");
            return (Criteria) this;
        }

        public Criteria andTradeIdIsNull() {
            addCriterion("trade_id is null");
            return (Criteria) this;
        }

        public Criteria andTradeIdIsNotNull() {
            addCriterion("trade_id is not null");
            return (Criteria) this;
        }

        public Criteria andTradeIdEqualTo(String value) {
            addCriterion("trade_id =", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdNotEqualTo(String value) {
            addCriterion("trade_id <>", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdGreaterThan(String value) {
            addCriterion("trade_id >", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdGreaterThanOrEqualTo(String value) {
            addCriterion("trade_id >=", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdLessThan(String value) {
            addCriterion("trade_id <", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdLessThanOrEqualTo(String value) {
            addCriterion("trade_id <=", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdLike(String value) {
            addCriterion("trade_id like", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdNotLike(String value) {
            addCriterion("trade_id not like", value, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdIn(List<String> values) {
            addCriterion("trade_id in", values, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdNotIn(List<String> values) {
            addCriterion("trade_id not in", values, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdBetween(String value1, String value2) {
            addCriterion("trade_id between", value1, value2, "tradeId");
            return (Criteria) this;
        }

        public Criteria andTradeIdNotBetween(String value1, String value2) {
            addCriterion("trade_id not between", value1, value2, "tradeId");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberIsNull() {
            addCriterion("m_order_number is null");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberIsNotNull() {
            addCriterion("m_order_number is not null");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberEqualTo(String value) {
            addCriterion("m_order_number =", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberNotEqualTo(String value) {
            addCriterion("m_order_number <>", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberGreaterThan(String value) {
            addCriterion("m_order_number >", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberGreaterThanOrEqualTo(String value) {
            addCriterion("m_order_number >=", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberLessThan(String value) {
            addCriterion("m_order_number <", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberLessThanOrEqualTo(String value) {
            addCriterion("m_order_number <=", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberLike(String value) {
            addCriterion("m_order_number like", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberNotLike(String value) {
            addCriterion("m_order_number not like", value, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberIn(List<String> values) {
            addCriterion("m_order_number in", values, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberNotIn(List<String> values) {
            addCriterion("m_order_number not in", values, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberBetween(String value1, String value2) {
            addCriterion("m_order_number between", value1, value2, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andMOrderNumberNotBetween(String value1, String value2) {
            addCriterion("m_order_number not between", value1, value2, "mOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberIsNull() {
            addCriterion("outer_order_number is null");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberIsNotNull() {
            addCriterion("outer_order_number is not null");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberEqualTo(String value) {
            addCriterion("outer_order_number =", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotEqualTo(String value) {
            addCriterion("outer_order_number <>", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberGreaterThan(String value) {
            addCriterion("outer_order_number >", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberGreaterThanOrEqualTo(String value) {
            addCriterion("outer_order_number >=", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberLessThan(String value) {
            addCriterion("outer_order_number <", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberLessThanOrEqualTo(String value) {
            addCriterion("outer_order_number <=", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberLike(String value) {
            addCriterion("outer_order_number like", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotLike(String value) {
            addCriterion("outer_order_number not like", value, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberIn(List<String> values) {
            addCriterion("outer_order_number in", values, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotIn(List<String> values) {
            addCriterion("outer_order_number not in", values, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberBetween(String value1, String value2) {
            addCriterion("outer_order_number between", value1, value2, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andOuterOrderNumberNotBetween(String value1, String value2) {
            addCriterion("outer_order_number not between", value1, value2, "outerOrderNumber");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNull() {
            addCriterion("pay_type is null");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNotNull() {
            addCriterion("pay_type is not null");
            return (Criteria) this;
        }

        public Criteria andPayTypeEqualTo(String value) {
            addCriterion("pay_type =", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotEqualTo(String value) {
            addCriterion("pay_type <>", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThan(String value) {
            addCriterion("pay_type >", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThanOrEqualTo(String value) {
            addCriterion("pay_type >=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThan(String value) {
            addCriterion("pay_type <", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThanOrEqualTo(String value) {
            addCriterion("pay_type <=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLike(String value) {
            addCriterion("pay_type like", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotLike(String value) {
            addCriterion("pay_type not like", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeIn(List<String> values) {
            addCriterion("pay_type in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotIn(List<String> values) {
            addCriterion("pay_type not in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeBetween(String value1, String value2) {
            addCriterion("pay_type between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotBetween(String value1, String value2) {
            addCriterion("pay_type not between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameIsNull() {
            addCriterion("pay_type_name is null");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameIsNotNull() {
            addCriterion("pay_type_name is not null");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameEqualTo(String value) {
            addCriterion("pay_type_name =", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameNotEqualTo(String value) {
            addCriterion("pay_type_name <>", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameGreaterThan(String value) {
            addCriterion("pay_type_name >", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("pay_type_name >=", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameLessThan(String value) {
            addCriterion("pay_type_name <", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameLessThanOrEqualTo(String value) {
            addCriterion("pay_type_name <=", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameLike(String value) {
            addCriterion("pay_type_name like", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameNotLike(String value) {
            addCriterion("pay_type_name not like", value, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameIn(List<String> values) {
            addCriterion("pay_type_name in", values, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameNotIn(List<String> values) {
            addCriterion("pay_type_name not in", values, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameBetween(String value1, String value2) {
            addCriterion("pay_type_name between", value1, value2, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andPayTypeNameNotBetween(String value1, String value2) {
            addCriterion("pay_type_name not between", value1, value2, "payTypeName");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlIsNull() {
            addCriterion("refund_notify_url is null");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlIsNotNull() {
            addCriterion("refund_notify_url is not null");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlEqualTo(String value) {
            addCriterion("refund_notify_url =", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlNotEqualTo(String value) {
            addCriterion("refund_notify_url <>", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlGreaterThan(String value) {
            addCriterion("refund_notify_url >", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlGreaterThanOrEqualTo(String value) {
            addCriterion("refund_notify_url >=", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlLessThan(String value) {
            addCriterion("refund_notify_url <", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlLessThanOrEqualTo(String value) {
            addCriterion("refund_notify_url <=", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlLike(String value) {
            addCriterion("refund_notify_url like", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlNotLike(String value) {
            addCriterion("refund_notify_url not like", value, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlIn(List<String> values) {
            addCriterion("refund_notify_url in", values, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlNotIn(List<String> values) {
            addCriterion("refund_notify_url not in", values, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlBetween(String value1, String value2) {
            addCriterion("refund_notify_url between", value1, value2, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andRefundNotifyUrlNotBetween(String value1, String value2) {
            addCriterion("refund_notify_url not between", value1, value2, "refundNotifyUrl");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberIsNull() {
            addCriterion("third_refund_number is null");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberIsNotNull() {
            addCriterion("third_refund_number is not null");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberEqualTo(String value) {
            addCriterion("third_refund_number =", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberNotEqualTo(String value) {
            addCriterion("third_refund_number <>", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberGreaterThan(String value) {
            addCriterion("third_refund_number >", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberGreaterThanOrEqualTo(String value) {
            addCriterion("third_refund_number >=", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberLessThan(String value) {
            addCriterion("third_refund_number <", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberLessThanOrEqualTo(String value) {
            addCriterion("third_refund_number <=", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberLike(String value) {
            addCriterion("third_refund_number like", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberNotLike(String value) {
            addCriterion("third_refund_number not like", value, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberIn(List<String> values) {
            addCriterion("third_refund_number in", values, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberNotIn(List<String> values) {
            addCriterion("third_refund_number not in", values, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberBetween(String value1, String value2) {
            addCriterion("third_refund_number between", value1, value2, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andThirdRefundNumberNotBetween(String value1, String value2) {
            addCriterion("third_refund_number not between", value1, value2, "thirdRefundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIsNull() {
            addCriterion("refund_number is null");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIsNotNull() {
            addCriterion("refund_number is not null");
            return (Criteria) this;
        }

        public Criteria andRefundNumberEqualTo(String value) {
            addCriterion("refund_number =", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotEqualTo(String value) {
            addCriterion("refund_number <>", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberGreaterThan(String value) {
            addCriterion("refund_number >", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberGreaterThanOrEqualTo(String value) {
            addCriterion("refund_number >=", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLessThan(String value) {
            addCriterion("refund_number <", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLessThanOrEqualTo(String value) {
            addCriterion("refund_number <=", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberLike(String value) {
            addCriterion("refund_number like", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotLike(String value) {
            addCriterion("refund_number not like", value, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberIn(List<String> values) {
            addCriterion("refund_number in", values, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotIn(List<String> values) {
            addCriterion("refund_number not in", values, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberBetween(String value1, String value2) {
            addCriterion("refund_number between", value1, value2, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundNumberNotBetween(String value1, String value2) {
            addCriterion("refund_number not between", value1, value2, "refundNumber");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIsNull() {
            addCriterion("refund_status is null");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIsNotNull() {
            addCriterion("refund_status is not null");
            return (Criteria) this;
        }

        public Criteria andRefundStatusEqualTo(String value) {
            addCriterion("refund_status =", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotEqualTo(String value) {
            addCriterion("refund_status <>", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusGreaterThan(String value) {
            addCriterion("refund_status >", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusGreaterThanOrEqualTo(String value) {
            addCriterion("refund_status >=", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLessThan(String value) {
            addCriterion("refund_status <", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLessThanOrEqualTo(String value) {
            addCriterion("refund_status <=", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLike(String value) {
            addCriterion("refund_status like", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotLike(String value) {
            addCriterion("refund_status not like", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIn(List<String> values) {
            addCriterion("refund_status in", values, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotIn(List<String> values) {
            addCriterion("refund_status not in", values, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusBetween(String value1, String value2) {
            addCriterion("refund_status between", value1, value2, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotBetween(String value1, String value2) {
            addCriterion("refund_status not between", value1, value2, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountIsNull() {
            addCriterion("refunded_amount is null");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountIsNotNull() {
            addCriterion("refunded_amount is not null");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountEqualTo(Long value) {
            addCriterion("refunded_amount =", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountNotEqualTo(Long value) {
            addCriterion("refunded_amount <>", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountGreaterThan(Long value) {
            addCriterion("refunded_amount >", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountGreaterThanOrEqualTo(Long value) {
            addCriterion("refunded_amount >=", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountLessThan(Long value) {
            addCriterion("refunded_amount <", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountLessThanOrEqualTo(Long value) {
            addCriterion("refunded_amount <=", value, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountIn(List<Long> values) {
            addCriterion("refunded_amount in", values, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountNotIn(List<Long> values) {
            addCriterion("refunded_amount not in", values, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountBetween(Long value1, Long value2) {
            addCriterion("refunded_amount between", value1, value2, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedAmountNotBetween(Long value1, Long value2) {
            addCriterion("refunded_amount not between", value1, value2, "refundedAmount");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeIsNull() {
            addCriterion("refunded_time is null");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeIsNotNull() {
            addCriterion("refunded_time is not null");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeEqualTo(Date value) {
            addCriterion("refunded_time =", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeNotEqualTo(Date value) {
            addCriterion("refunded_time <>", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeGreaterThan(Date value) {
            addCriterion("refunded_time >", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("refunded_time >=", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeLessThan(Date value) {
            addCriterion("refunded_time <", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeLessThanOrEqualTo(Date value) {
            addCriterion("refunded_time <=", value, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeIn(List<Date> values) {
            addCriterion("refunded_time in", values, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeNotIn(List<Date> values) {
            addCriterion("refunded_time not in", values, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeBetween(Date value1, Date value2) {
            addCriterion("refunded_time between", value1, value2, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRefundedTimeNotBetween(Date value1, Date value2) {
            addCriterion("refunded_time not between", value1, value2, "refundedTime");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoIsNull() {
            addCriterion("request_detail_info is null");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoIsNotNull() {
            addCriterion("request_detail_info is not null");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoEqualTo(String value) {
            addCriterion("request_detail_info =", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoNotEqualTo(String value) {
            addCriterion("request_detail_info <>", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoGreaterThan(String value) {
            addCriterion("request_detail_info >", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoGreaterThanOrEqualTo(String value) {
            addCriterion("request_detail_info >=", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoLessThan(String value) {
            addCriterion("request_detail_info <", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoLessThanOrEqualTo(String value) {
            addCriterion("request_detail_info <=", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoLike(String value) {
            addCriterion("request_detail_info like", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoNotLike(String value) {
            addCriterion("request_detail_info not like", value, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoIn(List<String> values) {
            addCriterion("request_detail_info in", values, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoNotIn(List<String> values) {
            addCriterion("request_detail_info not in", values, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoBetween(String value1, String value2) {
            addCriterion("request_detail_info between", value1, value2, "requestDetailInfo");
            return (Criteria) this;
        }

        public Criteria andRequestDetailInfoNotBetween(String value1, String value2) {
            addCriterion("request_detail_info not between", value1, value2, "requestDetailInfo");
            return (Criteria) this;
        }

        ///////


        public Criteria andResultDetailInfoIsNull() {
            addCriterion("result_detail_info is null");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoIsNotNull() {
            addCriterion("result_detail_info is not null");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoEqualTo(String value) {
            addCriterion("result_detail_info =", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoNotEqualTo(String value) {
            addCriterion("result_detail_info <>", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoGreaterThan(String value) {
            addCriterion("result_detail_info >", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoGreaterThanOrEqualTo(String value) {
            addCriterion("result_detail_info >=", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoLessThan(String value) {
            addCriterion("result_detail_info <", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoLessThanOrEqualTo(String value) {
            addCriterion("result_detail_info <=", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoLike(String value) {
            addCriterion("result_detail_info like", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoNotLike(String value) {
            addCriterion("result_detail_info not like", value, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoIn(List<String> values) {
            addCriterion("result_detail_info in", values, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoNotIn(List<String> values) {
            addCriterion("result_detail_info not in", values, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoBetween(String value1, String value2) {
            addCriterion("result_detail_info between", value1, value2, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andResultDetailInfoNotBetween(String value1, String value2) {
            addCriterion("result_detail_info not between", value1, value2, "resultDetailInfo");
            return (Criteria) this;
        }

        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria) this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria) this;
        }

        public Criteria andVersionEqualTo(Integer value) {
            addCriterion("version =", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotEqualTo(Integer value) {
            addCriterion("version <>", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThan(Integer value) {
            addCriterion("version >", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(Integer value) {
            addCriterion("version >=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThan(Integer value) {
            addCriterion("version <", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThanOrEqualTo(Integer value) {
            addCriterion("version <=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionIn(List<Integer> values) {
            addCriterion("version in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotIn(List<Integer> values) {
            addCriterion("version not in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionBetween(Integer value1, Integer value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotBetween(Integer value1, Integer value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNull() {
            addCriterion("updated_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNotNull() {
            addCriterion("updated_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByEqualTo(String value) {
            addCriterion("updated_by =", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotEqualTo(String value) {
            addCriterion("updated_by <>", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThan(String value) {
            addCriterion("updated_by >", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThanOrEqualTo(String value) {
            addCriterion("updated_by >=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThan(String value) {
            addCriterion("updated_by <", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThanOrEqualTo(String value) {
            addCriterion("updated_by <=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLike(String value) {
            addCriterion("updated_by like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotLike(String value) {
            addCriterion("updated_by not like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIn(List<String> values) {
            addCriterion("updated_by in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotIn(List<String> values) {
            addCriterion("updated_by not in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByBetween(String value1, String value2) {
            addCriterion("updated_by between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotBetween(String value1, String value2) {
            addCriterion("updated_by not between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}